Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 1047)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1053)
@@ -20,5 +20,8 @@
 ! Current revisions:
 ! -----------------
-!
+! implementation of two new prognostic equations for rain drop concentration (nr)
+! and rain water content (qr)
+!
+! currently, only available for cache loop optimization
 !
 ! Former revisions:
@@ -154,4 +157,5 @@
     USE diffusion_w_mod
     USE impact_of_latent_heat_mod
+    USE microphysics_mod
     USE plant_canopy_model_mod
     USE production_e_mod
@@ -409,4 +413,31 @@
 
 !
+!--      If required, calculate tendencies for total water content, rain water 
+!--      content, rain drop concentration and liquid temperature
+
+         IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+
+            tend_q(:,j,i)  = 0.0
+            tend_qr(:,j,i) = 0.0
+            tend_nr(:,j,i) = 0.0
+            tend_pt(:,j,i) = 0.0
+!
+!--         Droplet size distribution (dsd) properties are needed for the 
+!--         computation of selfcollection, breakup, evaporation and 
+!--         sedimentation of rain.  
+            IF ( precipitation )  THEN
+               CALL dsd_properties( i,j ) 
+               CALL autoconversion( i,j )
+               CALL accretion( i,j )
+               CALL selfcollection_breakup( i,j )
+               CALL evaporation_rain( i,j )
+               CALL sedimentation_rain( i,j )
+            ENDIF
+
+            IF ( drizzle )  CALL sedimentation_cloud( i,j )
+
+         ENDIF
+
+!
 !--       If required, compute prognostic equation for potential temperature
           IF ( .NOT. neutral )  THEN
@@ -433,8 +464,11 @@
              ENDIF
 
-!
-!--          If required compute impact of latent heat due to precipitation
-             IF ( precipitation )  THEN
-                CALL impact_of_latent_heat( i, j )
+!--          Using microphysical tendencies (latent heat)
+             IF ( cloud_physics )  THEN
+                IF ( icloud_scheme == 0 )  THEN
+                   tend(:,j,i) = tend(:,j,i) + tend_pt(:,j,i)
+                ELSEIF ( icloud_scheme == 1 .AND. precipitation)  THEN
+                   CALL impact_of_latent_heat( i, j ) 
+                ENDIF
              ENDIF
 
@@ -555,16 +589,19 @@
              ENDIF
              CALL diffusion_s( i, j, q, qsws, qswst, wall_qflux )
-       
-!
-!--          If required compute decrease of total water content due to
-!--          precipitation
-             IF ( precipitation )  THEN
-                CALL calc_precipitation( i, j )
-             ENDIF
-
+     
+!
+!--          Using microphysical tendencies
+             IF ( cloud_physics )  THEN
+                IF ( icloud_scheme == 0 )  THEN
+                   tend(:,j,i) = tend(:,j,i) + tend_q(:,j,i)
+                ELSEIF ( icloud_scheme == 1 .AND. precipitation )  THEN
+                   CALL calc_precipitation( i, j )
+                ENDIF
+             ENDIF
 !
 !--          Sink or source of scalar concentration due to canopy elements
              IF ( plant_canopy ) CALL plant_canopy_model( i, j, 5 )
 
+!
 !--          If required compute influence of large-scale subsidence/ascent
              IF ( large_scale_subsidence )  THEN
@@ -598,4 +635,119 @@
                    ENDDO
                 ENDIF
+             ENDIF
+
+!
+!--          If required, calculate prognostic equations for rain water content 
+!--          and rain drop concentration
+             IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+!
+!--             Calculate prognostic equation for rain water content
+                tend(:,j,i) = 0.0
+                IF ( timestep_scheme(1:5) == 'runge' ) &
+                THEN
+                   IF ( ws_scheme_sca )  THEN
+                      CALL advec_s_ws( i, j, qr, 'qr', flux_s_qr,       & 
+                                       diss_s_qr, flux_l_qr, diss_l_qr, &
+                                       i_omp_start, tn )
+                   ELSE 
+                      CALL advec_s_pw( i, j, qr )
+                   ENDIF
+                ELSE
+                   CALL advec_s_up( i, j, qr )
+                ENDIF
+                CALL diffusion_s( i, j, qr, qrsws, qrswst, wall_qrflux )
+
+!
+!--             Using microphysical tendencies (autoconversion, accretion, 
+!--             evaporation; if required: sedimentation)
+                tend(:,j,i) = tend(:,j,i) + tend_qr(:,j,i)
+
+!
+!--             If required, compute influence of large-scale subsidence/ascent
+                IF ( large_scale_subsidence )  THEN
+                   CALL subsidence( i, j, tend, qr, qr_init )
+                ENDIF
+
+!              CALL user_actions( i, j, 'qr-tendency' )
+
+!
+!--             Prognostic equation for rain water content
+                DO  k = nzb_s_inner(j,i)+1, nzt
+                   qr_p(k,j,i) = qr(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +    &
+                                                     tsc(3) * tqr_m(k,j,i) )     &
+                                         - tsc(5) * rdf_sc(k) *                  &
+                                        ( qr(k,j,i) - qr_init(k) )
+                   IF ( qr_p(k,j,i) < 0.0 )  qr_p(k,j,i) = 0.1 * qr(k,j,i)
+                ENDDO
+!
+!--             Calculate tendencies for the next Runge-Kutta step
+                IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                   IF ( intermediate_timestep_count == 1 )  THEN
+                      DO  k = nzb_s_inner(j,i)+1, nzt
+                         tqr_m(k,j,i) = tend(k,j,i)
+                      ENDDO
+                   ELSEIF ( intermediate_timestep_count < &
+                            intermediate_timestep_count_max )  THEN
+                      DO  k = nzb_s_inner(j,i)+1, nzt
+                         tqr_m(k,j,i) = -9.5625 * tend(k,j,i) + &
+                                        5.3125 * tqr_m(k,j,i)
+                      ENDDO
+                   ENDIF
+                ENDIF
+
+!
+!--             Calculate prognostic equation for rain drop concentration.
+                tend(:,j,i) = 0.0
+                IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                   IF ( ws_scheme_sca )  THEN
+                      CALL advec_s_ws( i, j, nr, 'nr', flux_s_nr,    & 
+                                    diss_s_nr, flux_l_nr, diss_l_nr, &
+                                    i_omp_start, tn )
+                   ELSE 
+                      CALL advec_s_pw( i, j, nr )
+                   ENDIF
+                ELSE
+                   CALL advec_s_up( i, j, nr )
+                ENDIF
+                CALL diffusion_s( i, j, nr, nrsws, nrswst, wall_nrflux )
+
+!--             Using microphysical tendencies (autoconversion, accretion, 
+!--             selfcollection, breakup, evaporation; 
+!--             if required: sedimentation)
+                tend(:,j,i) = tend(:,j,i) + tend_nr(:,j,i)
+
+!
+!--             If required, compute influence of large-scale subsidence/ascent
+                IF ( large_scale_subsidence )  THEN
+                   CALL subsidence( i, j, tend, nr, nr_init )
+                ENDIF
+
+!                CALL user_actions( i, j, 'nr-tendency' )
+
+!
+!--             Prognostic equation for rain drop concentration
+                DO  k = nzb_s_inner(j,i)+1, nzt
+                   nr_p(k,j,i) = nr(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) + &
+                                                  tsc(3) * tnr_m(k,j,i) )     &
+                                      - tsc(5) * rdf_sc(k) *                  &
+                                        ( nr(k,j,i) - nr_init(k) )
+                   IF ( nr_p(k,j,i) < 0.0 )  nr_p(k,j,i) = 0.1 * nr(k,j,i)
+                ENDDO
+!
+!--             Calculate tendencies for the next Runge-Kutta step
+                IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                   IF ( intermediate_timestep_count == 1 )  THEN
+                      DO  k = nzb_s_inner(j,i)+1, nzt
+                         tnr_m(k,j,i) = tend(k,j,i)
+                      ENDDO
+                   ELSEIF ( intermediate_timestep_count < &
+                            intermediate_timestep_count_max )  THEN
+                      DO  k = nzb_s_inner(j,i)+1, nzt
+                         tnr_m(k,j,i) = -9.5625 * tend(k,j,i) + &
+                                        5.3125 * tnr_m(k,j,i)
+                      ENDDO
+                   ENDIF
+                ENDIF
+
              ENDIF
 
Index: palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/read_3d_binary.f90	(revision 1047)
+++ palm/trunk/SOURCE/read_3d_binary.f90	(revision 1053)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! -----------------
-!
+! necessary expansions according to the two new prognostic equations (nr, qr) 
+! of the two-moment cloud physics scheme:
+! +prr, prr_av, *, *_av, *s, *sws, *swst
 !
 ! Former revisions:
@@ -279,5 +281,5 @@
 !--    First compare the version numbers
        READ ( 13 )  version_on_file
-       binary_version = '3.2'
+       binary_version = '3.3'
        IF ( TRIM( version_on_file ) /= TRIM( binary_version ) )  THEN
           WRITE( message_string, * ) 'version mismatch concerning data ',      &
@@ -457,4 +459,20 @@
                                    tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
+                CASE ( 'prr' )
+                   IF ( .NOT. ALLOCATED( prr ) )  THEN
+                      ALLOCATE( prr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   prr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'prr_av' )
+                   IF ( .NOT. ALLOCATED( prr_av ) )  THEN
+                      ALLOCATE( prr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   prr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
                 CASE ( 'precipitation_amount' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
@@ -508,4 +526,60 @@
                    ql_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
                                        tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'qr' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   qr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'nr' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   nr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'qr_av' )
+                   IF ( .NOT. ALLOCATED( qr_av ) )  THEN
+                      ALLOCATE( qr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   qr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                    tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'nr_av' )
+                   IF ( .NOT. ALLOCATED( nr_av ) )  THEN
+                      ALLOCATE( nr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   nr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                    tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'qrs' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   qrs(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'qrsws' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   qrsws(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'qrswst' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   qrswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'nrs' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   nrs(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'nrsws' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   nrsws(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'nrswst' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   nrswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'ql_c_av' )
Index: palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- palm/trunk/SOURCE/read_var_list.f90	(revision 1047)
+++ palm/trunk/SOURCE/read_var_list.f90	(revision 1053)
@@ -20,5 +20,13 @@
 ! Current revisions:
 ! ------------------
-!
+! necessary expansions according to the two new prognostic equations (nr, qr) 
+! of the two-moment cloud physics scheme:
+! +bc_*_b, +bc_*_t, +bc_*_t_val, *_init, *_surface, *_surface_initial_change,
+! +*_vertical_gradient, +*_vertical_gradient_level, *_vertical_gradient_level_ind,
+! +surface_waterflux_*
+!
+! in addition, steering parameters parameters of the two-moment cloud physics 
+! scheme:   
+! +cloud_scheme, +drizzle, +mu_constant, +mu_constant_value, +ventilation_effect
 !
 ! Former revisions:
@@ -169,5 +177,5 @@
 !-- Make version number check first
     READ ( 13 )  version_on_file
-    binary_version = '3.5'
+    binary_version = '3.6'
     IF ( TRIM( version_on_file ) /= TRIM( binary_version ) )  THEN
        WRITE( message_string, * ) 'version mismatch concerning control ', &
@@ -235,5 +243,5 @@
        ALLOCATE( lad(0:nz+1), ug(0:nz+1), u_init(0:nz+1), vg(0:nz+1),    &
                  v_init(0:nz+1), pt_init(0:nz+1), q_init(0:nz+1),        &
-                 sa_init(0:nz+1),                                        &
+                 qr_init(0:nz+1), nr_init(0:nz+1), sa_init(0:nz+1),      &
                  hom(0:nz+1,2,pr_palm+max_pr_user,0:statistic_regions),  &
                  hom_sum(0:nz+1,pr_palm+max_pr_user,0:statistic_regions) )
@@ -268,4 +276,10 @@
           CASE ( 'bc_ns' )
              READ ( 13 )  bc_ns
+          CASE ( 'bc_nr_b' )
+             READ ( 13 )  bc_nr_b
+          CASE ( 'bc_nr_t' )
+             READ ( 13 )  bc_nr_t
+          CASE ( 'bc_nr_t_val' )
+             READ ( 13 )  bc_nr_t_val
           CASE ( 'bc_p_b' )
              READ ( 13 )  bc_p_b
@@ -284,4 +298,10 @@
           CASE ( 'bc_q_t_val' )
              READ ( 13 )  bc_q_t_val
+          CASE ( 'bc_qr_b' )
+             READ ( 13 )  bc_qr_b
+          CASE ( 'bc_qr_t' )
+             READ ( 13 )  bc_qr_t
+          CASE ( 'bc_qr_t_val' )
+             READ ( 13 )  bc_qr_t_val
           CASE ( 'bc_s_b' )
              READ ( 13 )  bc_s_b
@@ -326,4 +346,6 @@
           CASE ( 'cloud_physics' )
              READ ( 13 )  cloud_physics
+          CASE ( 'cloud_scheme' )
+             READ ( 13 )  cloud_scheme
           CASE ( 'collective_wait' )
              READ ( 13 )  collective_wait
@@ -356,4 +378,6 @@
           CASE ( 'drag_coefficient' )
              READ ( 13 )  drag_coefficient
+          CASE ( 'drizzle' )
+             READ ( 13 )  drizzle
           CASE ( 'dt_pr_1d' )
              READ ( 13 )  dt_pr_1d
@@ -438,4 +462,8 @@
           CASE ( 'momentum_advec' )
              READ ( 13 )  momentum_advec
+          CASE ( 'mu_constant' )
+             READ ( 13 )  mu_constant
+          CASE ( 'mu_constant_value' )
+             READ ( 13 )  mu_constant_value
           CASE ( 'netcdf_precision' )
              READ ( 13 )  netcdf_precision
@@ -444,4 +472,16 @@
           CASE ( 'ngsrb' )
              READ ( 13 )  ngsrb
+          CASE ( 'nr_init' )
+             READ ( 13 )  nr_init
+          CASE ( 'nr_surface' )
+             READ ( 13 )  nr_surface
+          CASE ( 'nr_surface_initial_change' )
+             READ ( 13 )  nr_surface_initial_change
+          CASE ( 'nr_vertical_gradient' )
+             READ ( 13 )  nr_vertical_gradient
+          CASE ( 'nr_vertical_gradient_level' )
+             READ ( 13 )  nr_vertical_gradient_level
+          CASE ( 'nr_vertical_gradient_level_ind' )
+             READ ( 13 )  nr_vertical_gradient_level_ind
           CASE ( 'nsor' )
              READ ( 13 )  nsor
@@ -510,4 +550,16 @@
           CASE ( 'q_vertical_gradient_level_ind' )
              READ ( 13 )  q_vertical_gradient_level_ind
+          CASE ( 'qr_init' )
+             READ ( 13 )  qr_init
+          CASE ( 'qr_surface' )
+             READ ( 13 )  qr_surface
+          CASE ( 'qr_surface_initial_change' )
+             READ ( 13 )  qr_surface_initial_change
+          CASE ( 'qr_vertical_gradient' )
+             READ ( 13 )  qr_vertical_gradient
+          CASE ( 'qr_vertical_gradient_level' )
+             READ ( 13 )  qr_vertical_gradient_level
+          CASE ( 'qr_vertical_gradient_level_ind' )
+             READ ( 13 )  qr_vertical_gradient_level_ind
           CASE ( 'radiation' )
              READ ( 13 )  radiation
@@ -555,5 +607,9 @@
              READ ( 13 )  surface_scalarflux             
           CASE ( 'surface_waterflux' )
-             READ ( 13 )  surface_waterflux             
+             READ ( 13 )  surface_waterflux      
+          CASE ( 'surface_waterflux_nr' )
+             READ ( 13 )  surface_waterflux_nr    
+          CASE ( 'surface_waterflux_qr' )
+             READ ( 13 )  surface_waterflux_qr    
           CASE ( 's_surface' )
              READ ( 13 )  s_surface
@@ -656,4 +712,6 @@
           CASE ( 'v_max_ijk' )
              READ ( 13 )  v_max_ijk
+          CASE ( 'ventilation_effect' )
+             READ ( 13 )  ventilation_effect
           CASE ( 'vg' )
              READ ( 13 )  vg
Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1047)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1053)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! +nr, prr, qr
 !
 ! Former revisions:
@@ -115,4 +115,10 @@
                 lwp_av = 0.0
 
+             CASE ( 'nr' )
+                IF ( .NOT. ALLOCATED( nr_av ) )  THEN
+                   ALLOCATE( nr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                nr_av = 0.0
+
              CASE ( 'p' )
                 IF ( .NOT. ALLOCATED( p_av ) )  THEN
@@ -133,4 +139,10 @@
                 pr_av = 0.0
 
+             CASE ( 'prr' )
+                IF ( .NOT. ALLOCATED( prr_av ) )  THEN
+                   ALLOCATE( prr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                prr_av = 0.0
+
              CASE ( 'prr*' )
                 IF ( .NOT. ALLOCATED( precipitation_rate_av ) )  THEN
@@ -175,4 +187,10 @@
                 ql_vp_av = 0.0
 
+             CASE ( 'qr' )
+                IF ( .NOT. ALLOCATED( qr_av ) )  THEN
+                   ALLOCATE( qr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                qr_av = 0.0
+
              CASE ( 'qsws*' )
                 IF ( .NOT. ALLOCATED( qsws_av ) )  THEN
@@ -301,4 +319,13 @@
                    lwp_av(j,i) = lwp_av(j,i) + SUM( ql(nzb:nzt,j,i) * &
                                                     dzw(1:nzt+1) )
+                ENDDO
+             ENDDO
+
+          CASE ( 'nr' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      nr_av(k,j,i) = nr_av(k,j,i) + nr(k,j,i)
+                   ENDDO
                 ENDDO
              ENDDO
@@ -423,4 +450,13 @@
              ENDDO
 
+          CASE ( 'qr' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      qr_av(k,j,i) = qr_av(k,j,i) + qr(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+
           CASE ( 'qsws*' )
              DO  i = nxlg, nxrg
Index: palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- palm/trunk/SOURCE/swap_timelevel.f90	(revision 1047)
+++ palm/trunk/SOURCE/swap_timelevel.f90	(revision 1053)
@@ -20,6 +20,6 @@
 ! Current revisions:
 ! -----------------
+! swap of timelevels for nr, qr added
 ! 
-!
 ! Former revisions:
 ! -----------------
@@ -91,5 +91,9 @@
     ENDIF
     IF ( humidity  .OR.  passive_scalar )  THEN
-       q = q_p
+       q = q_p             
+       IF ( cloud_physics  .AND.  icloud_scheme == 0 )  THEN
+          qr = qr_p
+          nr = nr_p
+       ENDIF
     ENDIF
 
@@ -116,4 +120,8 @@
           IF ( humidity  .OR.  passive_scalar )  THEN
              q => q_1;    q_p => q_2
+             IF ( cloud_physics  .AND.  icloud_scheme == 0 )  THEN
+                qr => qr_1;    qr_p => qr_2
+                nr => nr_1;    nr_p => nr_2
+             ENDIF
           ENDIF
 
@@ -135,4 +143,8 @@
           IF ( humidity  .OR.  passive_scalar )  THEN
              q => q_2;    q_p => q_1
+             IF ( cloud_physics  .AND.  icloud_scheme == 0 )  THEN
+                qr => qr_2;    qr_p => qr_1
+                nr => nr_2;    nr_p => nr_1
+             ENDIF
           ENDIF
 
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 1047)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1053)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! exchange of ghost points for nr, qr added
 !
 ! Former revisions:
@@ -240,5 +240,11 @@
              CALL exchange_horiz( prho, nbgp )
           ENDIF
-          IF (humidity  .OR.  passive_scalar)  CALL exchange_horiz( q_p, nbgp )
+          IF (humidity  .OR.  passive_scalar)  THEN
+             CALL exchange_horiz( q_p, nbgp )
+             IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+                CALL exchange_horiz( qr_p, nbgp )
+                CALL exchange_horiz( nr_p, nbgp )
+             ENDIF
+          ENDIF
           IF ( cloud_droplets )  THEN
              CALL exchange_horiz( ql, nbgp )
Index: palm/trunk/SOURCE/timestep.f90
===================================================================
--- palm/trunk/SOURCE/timestep.f90	(revision 1047)
+++ palm/trunk/SOURCE/timestep.f90	(revision 1053)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-!
+! timestep is reduced in two-moment cloud scheme according to the maximum 
+! terminal velocity of rain drops
 !
 ! Former revisions:
@@ -75,4 +76,5 @@
 
     USE arrays_3d
+    USE cloud_parameters
     USE control_parameters
     USE cpulog
@@ -301,5 +303,6 @@
 !--    step minus a reduction (cfl_factor) to be on the safe side.
 !--    The time step must not exceed the maximum allowed value.
-       dt_3d = cfl_factor * MIN( dt_diff, dt_plant_canopy, dt_u, dt_v, dt_w )
+       dt_3d = cfl_factor * MIN( dt_diff, dt_plant_canopy, dt_u, dt_v, dt_w,   &
+                                 dt_precipitation )
        dt_3d = MIN( dt_3d, dt_max )
 
Index: palm/trunk/SOURCE/user_actions.f90
===================================================================
--- palm/trunk/SOURCE/user_actions.f90	(revision 1047)
+++ palm/trunk/SOURCE/user_actions.f90	(revision 1053)
@@ -20,4 +20,5 @@
 ! Current revisions:
 ! -----------------
+! +qr-tendency, nr-tendency
 !
 ! Former revisions:
@@ -136,4 +137,10 @@
 
 
+          CASE ( 'qr-tendency' )
+
+
+          CASE ( 'nr-tendency' )
+
+
           CASE DEFAULT
              message_string = 'unknown location "' // location // '"'
@@ -188,4 +195,10 @@
 
           CASE ( 'q-tendency' )
+
+
+          CASE ( 'qr-tendency' )
+
+
+          CASE ( 'nr-tendency' )
 
 
Index: palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/write_3d_binary.f90	(revision 1047)
+++ palm/trunk/SOURCE/write_3d_binary.f90	(revision 1053)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! -----------------
-!
+! necessary expansions according to the two new prognostic equations (nr, qr) 
+! of the two-moment cloud physics scheme:
+! +prr, prr_av, *, *_av, *s, *sws, *swst
 !
 ! Former revisions:
@@ -110,5 +112,5 @@
 !
 !-- Write arrays.
-    binary_version = '3.2'
+    binary_version = '3.3'
 
     WRITE ( 14 )  binary_version
@@ -145,4 +147,10 @@
        WRITE ( 14 )  'pr_av               ';  WRITE ( 14 )  pr_av
     ENDIF
+    IF ( ALLOCATED( prr ) )  THEN
+       WRITE ( 14 )  'prr                 ';  WRITE ( 14 )  prr
+    ENDIF
+    IF ( ALLOCATED( prr_av ) )  THEN
+       WRITE ( 14 )  'prr_av              ';  WRITE ( 14 )  prr_av
+    ENDIF
     IF ( ALLOCATED( precipitation_amount ) )  THEN
        WRITE ( 14 )  'precipitation_amount';  WRITE ( 14 )  precipitation_amount
@@ -166,4 +174,20 @@
              WRITE ( 14 )  'ql_av               ';  WRITE ( 14 )  ql_av
           ENDIF
+          IF ( icloud_scheme == 0 )  THEN
+             WRITE ( 14 )  'qr                  ';  WRITE ( 14 ) qr
+             WRITE ( 14 )  'nr                  ';  WRITE ( 14 ) nr
+             IF ( ALLOCATED( qr_av ) )  THEN
+                WRITE ( 14 )  'qr_av               ';  WRITE ( 14 )  qr_av
+             ENDIF
+             IF ( ALLOCATED( nr_av ) )  THEN
+                WRITE ( 14 )  'nr_av               ';  WRITE ( 14 )  nr_av
+             ENDIF
+             WRITE ( 14 )  'qrs                 ';  WRITE ( 14 ) qrs
+             WRITE ( 14 )  'qrsws               ';  WRITE ( 14 ) qrsws
+             WRITE ( 14 )  'qrswst              ';  WRITE ( 14 ) qrswst
+             WRITE ( 14 )  'nrs                 ';  WRITE ( 14 ) nrs
+             WRITE ( 14 )  'nrsws               ';  WRITE ( 14 ) nrsws
+             WRITE ( 14 )  'nrswst              ';  WRITE ( 14 ) nrswst
+          ENDIF
        ENDIF
        WRITE ( 14 )  'qs                  ';  WRITE ( 14 ) qs
Index: palm/trunk/SOURCE/write_var_list.f90
===================================================================
--- palm/trunk/SOURCE/write_var_list.f90	(revision 1047)
+++ palm/trunk/SOURCE/write_var_list.f90	(revision 1053)
@@ -20,5 +20,13 @@
 ! Current revisions:
 ! -----------------
-!
+! necessary expansions according to the two new prognostic equations (nr, qr) 
+! of the two-moment cloud physics scheme:
+! +bc_*_b, bc_*_t, bc_*_t_val, *_init, *_surface, *_surface_initial_change,
+! +*_vertical_gradient, *_vertical_gradient_level, *_vertical_gradient_level_ind,
+! +surface_waterflux_*
+!
+! in addition, steering parameters parameters of the two-moment cloud physics 
+! scheme:   
+! +cloud_scheme, +drizzle, +mu_constant, +mu_constant_value, +ventilation_effect
 !
 ! Former revisions:
@@ -151,5 +159,5 @@
 
 
-    binary_version = '3.5'
+    binary_version = '3.6'
 
     WRITE ( 14 )  binary_version
@@ -190,4 +198,10 @@
     WRITE ( 14 )  'bc_ns                         '
     WRITE ( 14 )  bc_ns
+    WRITE ( 14 )  'bc_nr_b                       '
+    WRITE ( 14 )  bc_nr_b
+    WRITE ( 14 )  'bc_nr_t                       '
+    WRITE ( 14 )  bc_nr_t
+    WRITE ( 14 )  'bc_nr_t_val                   '
+    WRITE ( 14 )  bc_nr_t_val
     WRITE ( 14 )  'bc_p_b                        '
     WRITE ( 14 )  bc_p_b
@@ -206,4 +220,10 @@
     WRITE ( 14 )  'bc_q_t_val                    '
     WRITE ( 14 )  bc_q_t_val
+    WRITE ( 14 )  'bc_qr_b                       '
+    WRITE ( 14 )  bc_qr_b
+    WRITE ( 14 )  'bc_qr_t                       '
+    WRITE ( 14 )  bc_qr_t
+    WRITE ( 14 )  'bc_qr_t_val                   '
+    WRITE ( 14 )  bc_qr_t_val
     WRITE ( 14 )  'bc_s_b                        '
     WRITE ( 14 )  bc_s_b
@@ -248,4 +268,6 @@
     WRITE ( 14 )  'cloud_physics                 '
     WRITE ( 14 )  cloud_physics
+    WRITE ( 14 )  'cloud_scheme                  '
+    WRITE ( 14 )  cloud_scheme
     WRITE ( 14 )  'collective_wait               '
     WRITE ( 14 )  collective_wait
@@ -278,4 +300,6 @@
     WRITE ( 14 )  'drag_coefficient              '
     WRITE ( 14 )  drag_coefficient
+    WRITE ( 14 )  'drizzle                       '
+    WRITE ( 14 )  drizzle
     WRITE ( 14 )  'dt_pr_1d                      '
     WRITE ( 14 )  dt_pr_1d
@@ -358,4 +382,8 @@
     WRITE ( 14 )  'momentum_advec                '
     WRITE ( 14 )  momentum_advec
+    WRITE ( 14 )  'mu_constant                   '
+    WRITE ( 14 )  mu_constant
+    WRITE ( 14 )  'mu_constant_value             '
+    WRITE ( 14 )  mu_constant_value
     WRITE ( 14 )  'netcdf_precision              '
     WRITE ( 14 )  netcdf_precision
@@ -364,4 +392,16 @@
     WRITE ( 14 )  'ngsrb                         '
     WRITE ( 14 )  ngsrb
+    WRITE ( 14 )  'nr_init                       '
+    WRITE ( 14 )  nr_init
+    WRITE ( 14 )  'nr_surface                    '
+    WRITE ( 14 )  nr_surface
+    WRITE ( 14 )  'nr_surface_initial_change     '
+    WRITE ( 14 )  nr_surface_initial_change
+    WRITE ( 14 )  'nr_vertical_gradient          '
+    WRITE ( 14 )  nr_vertical_gradient
+    WRITE ( 14 )  'nr_vertical_gradient_level    '
+    WRITE ( 14 )  nr_vertical_gradient_level
+    WRITE ( 14 )  'nr_vertical_gradient_level_ind'
+    WRITE ( 14 )  nr_vertical_gradient_level_ind
     WRITE ( 14 )  'nsor                          '
     WRITE ( 14 )  nsor
@@ -428,4 +468,16 @@
     WRITE ( 14 )  'q_vertical_gradient_level_ind '
     WRITE ( 14 )  q_vertical_gradient_level_ind
+    WRITE ( 14 )  'qr_init                       '
+    WRITE ( 14 )  qr_init
+    WRITE ( 14 )  'qr_surface                    '
+    WRITE ( 14 )  qr_surface
+    WRITE ( 14 )  'qr_surface_initial_change     '
+    WRITE ( 14 )  qr_surface_initial_change
+    WRITE ( 14 )  'qr_vertical_gradient          '
+    WRITE ( 14 )  qr_vertical_gradient
+    WRITE ( 14 )  'qr_vertical_gradient_level    '
+    WRITE ( 14 )  qr_vertical_gradient_level
+    WRITE ( 14 )  'qr_vertical_gradient_level_ind'
+    WRITE ( 14 )  qr_vertical_gradient_level_ind
     WRITE ( 14 )  'radiation                     '
     WRITE ( 14 )  radiation
@@ -474,4 +526,8 @@
     WRITE ( 14 )  'surface_waterflux             '
     WRITE ( 14 )  surface_waterflux    
+    WRITE ( 14 )  'surface_waterflux_nr          '
+    WRITE ( 14 )  surface_waterflux_nr    
+    WRITE ( 14 )  'surface_waterflux_qr          '
+    WRITE ( 14 )  surface_waterflux_qr    
     WRITE ( 14 )  's_surface                     '
     WRITE ( 14 )  s_surface
@@ -574,4 +630,6 @@
     WRITE ( 14 )  'v_max_ijk                     '
     WRITE ( 14 )  v_max_ijk
+    WRITE ( 14 )  'ventilation_effect            '
+    WRITE ( 14 )  ventilation_effect
     WRITE ( 14 )  'vg                            '
     WRITE ( 14 )  vg
